Module org.apache.sis.util
Package org.apache.sis.math

# Enum Class FunctionProperty

Object
Enum<FunctionProperty>
FunctionProperty

All Implemented Interfaces:
  `Serializable`, `Comparable<FunctionProperty>`, `Constable`

public enum FunctionProperty extends Enum<FunctionProperty>
The manners in which the inputs of a function are mapped to the outputs. The function doesn't need to be mathematical. For example, this enumeration can be used with `ObjectConverter`.

Any given function can have zero, one or more properties from this enumeration. Some properties not included in this enumeration can be expressed by a combination of other properties:

Inferred function properties
Property | How to build
--- | ---
Bijective | `EnumSet.of(INJECTIVE, SURJECTIVE)`
Monotonic | `EnumSet.of(INJECTIVE)` or `EnumSet​.of(SURJECTIVE)`
Strictly increasing | `EnumSet.of(ORDER_PRESERVING, INJECTIVE)`
Strictly decreasing | `EnumSet.of(ORDER_REVERSING, INJECTIVE)`
Constant | `EnumSet.of(ORDER_PRESERVING, ORDER_REVERSING)`

The Javadoc in this class uses the following terms:

- S (as in source) is the set of all possible input values (the domain).
- T (as in target) is a set containing all possible output values, and potentially more elements (the codomain). For example, the set of output values of the `Integer​.toString()` function is included in a larger set, which is the set of all possible `String` values. In this Javadoc, T stands for the latter set.

Since:
  0.3
See Also:
  - `ObjectConverter​.properties()`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class Enum

  `Enum​.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `INJECTIVE`
  A function is injective if each value of T is either unrelated to S, or is the output of exactly one value of S.
  `INVERTIBLE`
  A function is invertible if it can provide another function mapping T values to S values.
  `ORDER_PRESERVING`
  A function preserves order if any sequence of increasing S values is mapped to a sequence of increasing T values.
  `ORDER_REVERSING`
  A function reverses order if any sequence of increasing S values is mapped to a sequence of decreasing T values.
  `SURJECTIVE`
  A function is surjective if any value of T can be created from one or many values of S.
  `VOLATILE`
  A function is volatile if the computed value changes each time that the function is evaluated.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static EnumSet<FunctionProperty>`
  `concatenate(Set<FunctionProperty> step1, Set<FunctionProperty> step2)`
  Returns the properties of a function defined as the concatenation of two other functions.
  `static boolean`
  `isBijective(Set<FunctionProperty> properties)`
  Returns `true` if a function having the given set of properties is bijective.
  `static boolean`
  `isConstant(Set<FunctionProperty> properties)`
  Returns `true` if a function can only return a constant value.
  `static boolean`
  `isMonotonic(Set<FunctionProperty> properties)`
  Returns `true` if a function having the given set of properties is monotonic.
  `static FunctionProperty`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static FunctionProperty[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### INVERTIBLE

    public static final FunctionProperty INVERTIBLE
    A function is invertible if it can provide another function mapping T values to S values.

    While other values defined in this enumeration are more about the mathematical aspects of functions, this particular value is more about the programmatical aspect. A function may be conceptually invertible (all bijective functions should be), but the inverse operation may not be implemented. In such case, the function properties shall not include this `INVERTIBLE` value.

    See Also:
      - `ObjectConverter​.inverse()`

  - ### INJECTIVE

    public static final FunctionProperty INJECTIVE
    A function is injective if each value of T is either unrelated to S, or is the output of exactly one value of S. For example an `ObjectConverter` doing conversions from `Integer` to `String` is an injective function, because no pair of integers can produce the same string.

    A function which is both injective and surjective is a bijective function. In such functions, there is a one-to-one relationship between all input and output values.

    See Also:
      - `SURJECTIVE`
      - `isBijective(Set)`

  - ### SURJECTIVE

    public static final FunctionProperty SURJECTIVE
    A function is surjective if any value of T can be created from one or many values of S. For example an `ObjectConverter` doing conversions from `String` to `Integer` is a surjective function, because there is always at least one string for each integer value. Note that such function cannot be injective since many different strings can represent the same integer value.

    A function which is both injective and surjective is a bijective function. In such functions, there is a one-to-one relationship between all input and output values.

    See Also:
      - `INJECTIVE`
      - `isBijective(Set)`

  - ### ORDER_PRESERVING

    public static final FunctionProperty ORDER_PRESERVING
    A function preserves order if any sequence of increasing S values is mapped to a sequence of increasing T values. This enumeration constant can be used only with `Comparable` types or primitive types having a comparable wrapper.

    Strictly ordered input values are not necessarily mapped to strictly ordered output values. Strictness is preserved only if the function is also injective.

    A function may be both order preserving and order reversing if all input values are mapped to a constant output value.

    See Also:
      - `ORDER_REVERSING`
      - `isMonotonic(Set)`

  - ### ORDER_REVERSING

    public static final FunctionProperty ORDER_REVERSING
    A function reverses order if any sequence of increasing S values is mapped to a sequence of decreasing T values. This enumeration constant can be used only with `Comparable` types or primitive types having a comparable wrapper.

    Strictly ordered input values are not necessarily mapped to strictly ordered output values. Strictness is preserved only if the function is also injective.

    A function may be both order preserving and order reversing if all input values are mapped to a constant output value.

    See Also:
      - `ORDER_PRESERVING`
      - `isMonotonic(Set)`

  - ### VOLATILE

    public static final FunctionProperty VOLATILE
    A function is volatile if the computed value changes each time that the function is evaluated. It may be for example a random number generator, or a function returning the current date and time.
    Since:
      1.4

- ## Method Details

  - ### values

    public static FunctionProperty[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static FunctionProperty valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### isBijective

    public static boolean isBijective(Set<FunctionProperty> properties)
    Returns `true` if a function having the given set of properties is bijective. Bijective functions have a one-to-one relationship between all input and output values. This convenience method tests if the given set contains all following properties:
    - `INJECTIVE`
    - `SURJECTIVE`
    Parameters:
      `properties` - the properties of the function to test for bijectivity.
    Returns:
      `true` if a function having the given set of properties is bijective.

  - ### isMonotonic

    public static boolean isMonotonic(Set<FunctionProperty> properties)
    Returns `true` if a function having the given set of properties is monotonic. This convenience method tests if the given set contains at least one of the following properties:
    - `ORDER_PRESERVING`
    - `ORDER_REVERSING`
    Parameters:
      `properties` - the properties of the function to test for monotonicity.
    Returns:
      `true` if a function having the given set of properties is monotonic.

  - ### isConstant

    public static boolean isConstant(Set<FunctionProperty> properties)
    Returns `true` if a function can only return a constant value. This convenience method tests if the given set contains all of the following properties:
    - `ORDER_PRESERVING`
    - `ORDER_REVERSING`
    Parameters:
      `properties` - the properties of the function to test.
    Returns:
      `true` if the function can only return a constant value.
    Since:
      1.4

  - ### concatenate

    public static EnumSet<FunctionProperty> concatenate(Set<FunctionProperty> step1, Set<FunctionProperty> step2)
    Returns the properties of a function defined as the concatenation of two other functions. The presence of a property in the returned set is determined by combining the presence of the same property in the two steps using the following logical operations:
    - `INVERTIBLE`, `INJECTIVE`, `SURJECTIVE`, `ORDER_PRESERVING`: logical `AND` operation.
    - `ORDER_REVERSING`: Logical `XOR` operation if the other step is also ordered.
    - `VOLATILE`: logical `OR` operation.
    The returned set is always a new instance and is modifiable, thus allowing the caller to customize the property set.
    Parameters:
      `step1` - properties of the first function.
      `step2` - properties of the second function.
    Returns:
      properties of the concatenated function as a new and modifiable set.
    Since:
      1.4